local  HexMenu = Game:addState("HexMenu")

function HexMenu:enterState()
	if Game.started == false then
		Game:newGame()
	else
	loadHexArray()
	end
end

function HexMenu:update()
self:mouseHexCheck()
end

function HexMenu:draw()
love.graphics.draw(dungeonBackground,0,0)
-- Draws Hexes
self:drawHexes()
-- Draws the selection box
self:drawSelection()
-- Gui & vignetting
love.graphics.draw(hexMenuGUI,0,0)
love.graphics.draw(vignette,0,0)

-- Debug
love.graphics.print(mx ..", " .. my,0,0)
love.graphics.print(Game.currentHexX,0,30)

end

function HexMenu:keypressed(key)
	if key == "escape" then
		Game:gotoState("Menu")
	end
	if key == "z" then
		Game.currentHexX = Game.currentHexX - 1
	end
end

function HexMenu:mousepressed(x,y,button )
	if button == "l" then
		if Game.mouseSelected >0 and Game.mouseSelected  <7 then
			if self:changeHex() then
				Game.newMap = true
				Game:gotoState("Play")
			end
		end
	end

end

function HexMenu:exitState()

end

function HexMenu:drawDebug()


end

function HexMenu:mouseHexCheck()
local mr,mg,mb,a = hexCollision:getPixel(mx,my)
local mouseSum = mr+mg+mb
Game.mouseSelected = round(mouseSum/100,0)
end

function HexMenu:drawHexes()

	love.graphics.draw(Game.hexArray[7].graphic,240,256) -- center
	love.graphics.draw(Game.hexArray[6].graphic,240,0) -- top		
	love.graphics.draw(Game.hexArray[5].graphic,18,128) -- top left
	love.graphics.draw(Game.hexArray[4].graphic,18,384) -- bottom left	
	love.graphics.draw(Game.hexArray[3].graphic,240,512) -- bottom	
	love.graphics.draw(Game.hexArray[2].graphic,462,384) -- bottom right	
	love.graphics.draw(Game.hexArray[1].graphic,462,128) -- top right	

end

function HexMenu:drawSelection()
	if Game.mouseSelected == 7 then
		
		love.graphics.draw(selectedHex,240,256)
	elseif Game.mouseSelected == 6 then
	
		love.graphics.draw(selectedHex,240,0)
	elseif Game.mouseSelected == 5 then
	
		love.graphics.draw(selectedHex,18,128)
	elseif Game.mouseSelected == 4 then
		love.graphics.draw(selectedHex,18,384)
	elseif Game.mouseSelected == 3 then
		love.graphics.draw(selectedHex,240,512)
	elseif Game.mouseSelected == 2 then
		love.graphics.draw(selectedHex,462,384)
	elseif Game.mouseSelected == 1 then
		love.graphics.draw(selectedHex,462,128)
	end
end

function HexMenu:changeHex() 
	if Game.mouseSelected == 6 and Game.hexArray[6].tileType > 0 then
		Game.currentHexY = Game.currentHexY-1
		return true
	elseif Game.mouseSelected == 5 and Game.hexArray[5].tileType > 0 then
		Game.currentHexX = Game.currentHexX-1
		Game.currentHexY = Game.currentHexY+Game.cyMod-2
		return true
	elseif Game.mouseSelected == 4 and Game.hexArray[4].tileType > 0 then
		Game.currentHexX = Game.currentHexX-1
		Game.currentHexY = Game.currentHexY+Game.cyMod-1
		return true
	elseif Game.mouseSelected == 3 and Game.hexArray[3].tileType > 0 then
		Game.currentHexY = Game.currentHexY+1
		return true
	elseif Game.mouseSelected == 2 and Game.hexArray[2].tileType > 0 then
		Game.currentHexX = Game.currentHexX+1
		Game.currentHexY = Game.currentHexY+Game.cyMod-1
		return true
	elseif Game.mouseSelected == 1 and Game.hexArray[1].tileType > 0 then
		Game.currentHexX = Game.currentHexX+1
		Game.currentHexY = Game.currentHexY+Game.cyMod-2
		return true
	else
		return false
	end
end

function loadHexArray()
Game.hexArray = {}
local cx = Game.currentHexX
local cy = Game.currentHexY
-- This loads the hexes around the player into a temp array for the menu
Game.hexArray[7] = Game.HexMap.Tile[cx][cy]
Game.hexArray[6] = Game.HexMap.Tile[cx][cy-1]
Game.hexArray[3] = Game.HexMap.Tile[cx][cy+1]
	if cx % 2 == 0 then
		Game.cyMod = 2
		Game.hexArray[1] = Game.HexMap.Tile[cx+1][cy]
		Game.hexArray[2] = Game.HexMap.Tile[cx+1][cy+1]
		Game.hexArray[4] = Game.HexMap.Tile[cx-1][cy+1]	
		Game.hexArray[5] = Game.HexMap.Tile[cx-1][cy]
	else
		Game.cyMod = 1
		Game.hexArray[1] = Game.HexMap.Tile[cx+1][cy-1]
		Game.hexArray[2] = Game.HexMap.Tile[cx+1][cy]
		Game.hexArray[4] = Game.HexMap.Tile[cx-1][cy]	
		Game.hexArray[5] = Game.HexMap.Tile[cx-1][cy-1]
	end
end

function Game:newGame()
	hexTileLoader()
	math.randomseed(os.time())
	Game.HexMap = HexMap:new(16,16)
	Game.currentHexX = 15
	Game.currentHexY = 15
	-- This loads the hexes around the player into a temp array for the menu
	loadHexArray()
	Game.Player = Player:new()
	Game.started = true
end



