local  Play = Game:addState("Play")

function Play:enterState()
	if Game.newMap == true then
		Play:newLocalMap()
		Game.turn = true
	end
end

function Play:update()
	if Game.turn == true then
		Game.Player:update()
		Game.LocalMap:update()
		Game.turn = false
	end
end

function Play:draw()
love.graphics.scale(Game.width/1024,Game.height/768)
love.graphics.draw(dungeonBackground,0,0)
Game.LocalMap:draw()
Game.Player:draw()
love.graphics.draw(dungeonGUI,0,0)
love.graphics.print(Game.LocalMap.percentSeen .. "%",768,50)
-- love.graphics.print(#exitOptions,100,100)
end

function Play:keypressed(key)
	if key == "escape" then
		Game:gotoState("Menu")
	end
	if key == "z" then
		Game.newMap = true
		Play:newLocalMap()
	end
	if key == "x" then
		if Game.Player.control == "Knight" then
			Game.Player.control = "Princess"
			Game.Player.x = Game.Player.Princess.x
			Game.Player.y = Game.Player.Princess.y
		else
			Game.Player.control = "Knight"
			Game.Player.x = Game.Player.Knight.x
			Game.Player.y = Game.Player.Knight.y
		end
		
	end
	if key == "c" then
		Game.LocalMap:showAll()
	end
	if key == "w" or key == "kp8" then
		Game.Player:move(0,-1)

	elseif key == "d" or key == "kp6" then
		Game.Player:move(1,0)
	elseif key == "a" or key == "kp4" then
		Game.Player:move(-1,0)
	elseif key == "s" or key == "kp2" then
		Game.Player:move(0,1)
	elseif key == "kp3" then
		Game.Player:move(1,1)
	elseif key == "kp9" then
		Game.Player:move(1,-1)
	elseif	key == "kp1" then
		Game.Player:move(-1,1)
	elseif	key == "kp7" then
		Game.Player:move(-1,-1)
	end	
end

function Play:exitState()

end

function Play:drawDebug()


end

function Play:newLocalMap()
	local difficulty = hexTileType[Game.HexMap.Tile[Game.currentHexX][Game.currentHexY].tileType].difficulty
	local xSize = round((math.random(4,8)*32)*(difficulty/50),0)
	local ySize = round((math.random(4,8)*32)*(difficulty/50),0)
	local dungeonType = hexTileType[Game.HexMap.Tile[Game.currentHexX][Game.currentHexY].tileType].dungeonType
	Game.LocalMap = LocalMap:new(xSize,ySize,dungeonType,difficulty)
	Game.Player:goTo(Game.LocalMap.enterX,Game.LocalMap.enterY)
	Game.newMap = false
end



